package com.example.nto.controller;

import com.example.nto.model.entity.Code;
import com.example.nto.model.entity.Employee;
import com.example.nto.service.EmployeeService;
import lombok.RequiredArgsConstructor;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/api")
@RequiredArgsConstructor
public class EmployeeController {

    private final EmployeeService employeeService;

//    @PreAuthorize("hasAuthority('User', 'Admin')")
    @GetMapping("/info")
    public Employee info(@RequestParam final String login) {
        return employeeService.getEmployee(login);
    }

//    @PreAuthorize("hasAuthority('User', 'Admin')")
    @PatchMapping("/open")
    public void open(@RequestParam final String login, @RequestBody final Code code) {
        employeeService.updateVisit(login, code.getValue());
    }

    @PostMapping("/add")
    public void add(@RequestBody final Employee employee) {
        employeeService.addEmployee(employee);
    }
}
